// pages/blueconn/blueconn.js
var app = getApp()
var timerID = -1;
var closeBletimerID = 0;
Page({
    
    /**
     * 页面的初始数据
     */
    data: {
        list: [],
        services: [],
        serviceId: 1,
        writeCharacter: false,
        readCharacter: false,
        notifyCharacter: false,
        isScanning: false
    },

    //搜索设备
    startSearch: function () {
        var that = this
        wx.stopPullDownRefresh()
        wx.closeBluetoothAdapter({
            complete(res) {
                wx.openBluetoothAdapter({
                    success: function (res) {
                        wx.getBluetoothAdapterState({
                            success: function (res) {
                                console.log('openBluetoothAdapter success', res)
                                if (res.available) {
                                    if (res.discovering) {
                                        wx.stopBluetoothDevicesDiscovery({
                                            success: function (res) {console.log(res)}
                                        })
                                    } else {that.getBluetoothDevices()}
                                } else {
                                    wx.showModal({title: '提示',content: '本机蓝牙适配器不可用',showCancel: false})
                                }
                            },
                        })
                    },
                    fail: function () {
                        wx.showModal({title: '提示',content: '手机蓝牙未打开，请打开蓝牙！',showCancel: false })
                    }
                })
            }
        })
    },
    checkPemission: function () { //android 6.0以上需授权地理位置权限
        var that = this
        var platform = app.BLEInformation.platform
        if (platform == "ios") {
            app.globalData.platform = "ios"
            that.getBluetoothDevices()
        } else if (platform == "android") {
            app.globalData.platform = "android"
            console.log(app.getSystem().substring(app.getSystem().length - (app.getSystem().length - 8), app.getSystem().length - (app.getSystem().length - 8) + 1))
            if (app.getSystem().substring(app.getSystem().length - (app.getSystem().length - 8), app.getSystem().length - (app.getSystem().length - 8) + 1) > 5) {
                wx.getSetting({
                    success: function (res) {
                        console.log(res)
                        if (!res.authSetting['scope.userLocation']) {
                            wx.authorize({
                                scope: 'scope.userLocation',
                                complete: function (res) {
                                    that.getBluetoothDevices()
                                }
                            })
                        } else {
                            that.getBluetoothDevices()
                        }
                    }
                })
            }
        }
    },
    getBluetoothDevices: function () { //获取蓝牙设备信息
        var that = this
        
        console.log("start search")
        that.setData({
            isScanning: true
        })
        wx.startBluetoothDevicesDiscovery({
            success: function (res) {
                console.log(res)
                if(timerID != -1) return
                timerID = setInterval(function () {
                    wx.getBluetoothDevices({
                        success: function (res) {
                            console.log("searching...",res)
                            var devices = []
                            var num = 0
                            for (var i = 0; i < res.devices.length; ++i) {
                                if (res.devices[i].name != "未知设备" && res.devices[i].name.startsWith('WT')) {
                                    devices[num] = res.devices[i]
                                    num++
                                }
                                // if (res.devices[i].name != "未知设备" && res.devices[i].name != undefined && res.devices[i].name != null) {
                                //     devices[num] = res.devices[i]
                                //     num++
                                // }
                            }
                            that.setData({
                                list: devices,
                                isScanning: true
                            })
                            console.log(devices)
                        },
                    })
                }, 2500)
            },
        })
    },
    bindViewTap: function (e) {
        var that = this
        that.setData({
            isScanning: false
        })
        clearInterval(timerID);
        timerID = -1
        wx.stopBluetoothDevicesDiscovery({
            success: function (res) {
                console.log(res);
                console.log("停止搜索蓝牙")
            },
        })
        that.setData({
            serviceId: 1,
            writeCharacter: false,
            readCharacter: false,
            notifyCharacter: false
        })
        console.log(e.currentTarget.dataset.title)
        wx.showLoading({
            title: '正在连接',
            mask: true
        })
        wx.createBLEConnection({
            deviceId: e.currentTarget.dataset.title,
            success: function (res) {
                console.log(res)
                app.BLEInformation.deviceId = e.currentTarget.dataset.title
                that.getSeviceId()
            },
            fail: function (e) {
                wx.showModal({
                    title: '提示',
                    content: '连接失败',
                    showCancel: false
                })
                console.log(e)
                wx.hideLoading()
            },
            complete: function (e) {
                console.log(e)
            }
        })

    },

    getSeviceId: function () {
        var that = this
        var platform = app.BLEInformation.platform
        console.log(app.BLEInformation.deviceId)
        wx.getBLEDeviceServices({
            deviceId: app.BLEInformation.deviceId,
            success: function (res) {
                console.log("获取设备所有服务",res)
                that.setData({
                    services: res.services
                })
                that.getCharacteristics()
            },
            fail: function (e) {
                console.log(e)
            },
            complete: function (e) {
                console.log(e)
            }
        })
    },
    getCharacteristics: function () {
        var that = this
        var list = that.data.services
        var num = that.data.serviceId
        var write = that.data.writeCharacter
        var read = that.data.readCharacter
        var notify = that.data.notifyCharacter
        console.log("当前获取的服务uuid",list[num].uuid)
        wx.getBLEDeviceCharacteristics({
            deviceId: app.BLEInformation.deviceId,
            serviceId: list[num].uuid,
            success: function (res) {
                console.log("获取蓝牙低功耗设备某个服务中所有特征",res)
                for (var i = 0; i < res.characteristics.length; ++i) {
                    var properties = res.characteristics[i].properties
                    var item = res.characteristics[i].uuid
                    if (!notify) {
                        if (properties.notify) {
                            app.BLEInformation.notifyCharaterId = item
                            app.BLEInformation.notifyServiceId = list[num].uuid
                            notify = true
                        }
                    }
                    if (item.startsWith('0000C303')) {
                        if (properties.write) {
                            app.BLEInformation.writeCharaterId = item
                            app.BLEInformation.writeServiceId = list[num].uuid
                            write = true
                        }
                    }
                    if (!read) {
                        if (properties.read) {
                            app.BLEInformation.readCharaterId = item
                            app.BLEInformation.readServiceId = list[num].uuid
                            read = true
                        }
                    }
                }
                if (!write || !notify || !read) {
                    num++
                    that.setData({
                        writeCharacter: write,
                        readCharacter: read,
                        notifyCharacter: notify,
                        serviceId: num
                    })
                    if (num == list.length) {
                        wx.showModal({
                            title: '提示',
                            content: '找不到该读写的特征值',
                            showCancel: false
                        })
                    } else {
                        that.getCharacteristics()
                    }
                } else {
                    wx.navigateTo({
                      url: '/pages/connect_state/connect_state',
                    })
                }
            },
            fail: function (e) {
                console.log(e)
            },
        })
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        app.BLEInformation.platform = app.getPlatform()
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {
        this.startSearch();
        
        
    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {
       
    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {
        wx.closeBLEConnection({complete(res){console.log(res)}})
        wx.closeBluetoothAdapter({complete(res){console.log(res)}})
        clearInterval(timerID)
        clearTimeout(closeBletimerID)
        timerID = -1
        closeBletimerID = -1
        this.setData({
          list:[]
        })
    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {
        var that = this
        wx.startPullDownRefresh({})
        that.startSearch()
    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {
        var that = this
        wx.startPullDownRefresh({})
        that.startSearch()
    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})