// pages/connect_state/connect_state.js
var app = getApp()
var closeBletimerID = -1
var intervalID = -1
Page({

    /**
     * 页面的初始数据
     */
    data: {
        first_url:"/img/connect.gif",
        second_url:"/img/connect.gif",
        time:120,
        condition:0
    },
    
    stringToUtf8: function (str) {
      const buffer = new ArrayBuffer(str.length);
      const view = new Uint8Array(buffer);
      for (let i = 0; i < str.length; i++) {
          view[i] = str.charCodeAt(i);
      }
      return view;
    },
    ab2hex(buffer) {
        const hexArr = Array.prototype.map.call(
          new Uint8Array(buffer),
          function (bit) {
            return ('00' + bit.toString(16)).slice(-2)
          }
        )
        console.log('获取到设备到值',hexArr)
        // return hexArr.join('')
        return hexArr
    },
    openControl: function () {
        var that = this
        var writeNum=14; //代表固定的不包含wifi名称和wifi密码的总长度
        console.log(app.BLEInformation.writeCharaterId, app.BLEInformation.deviceId, app.BLEInformation.writeServiceId);
        var ssid = app.WIFIInformation.SSID //名称
        var pwd = app.WIFIInformation.PWD //密码
        var ssid_array = that.stringToUtf8(ssid); //转码
        writeNum=writeNum+ssid_array.length //长度累加
        var pwd_array = that.stringToUtf8(pwd); //转码
        writeNum=writeNum+pwd_array.length

        console.log("wifi名称",ssid.length.toString(16),ssid_array)
        console.log("wifi密码",pwd.length.toString(16),pwd_array)
        console.log("数据长度",writeNum)
        // 总长度 - 包头(1字节) - 包尾(1字节) = writeNum - 2
        const hexString = (writeNum-2).toString(16)
        const paddedHexString = hexString.padStart(4, '0');
        const byte1 = parseInt(paddedHexString.substring(0, 2), 16) & 255;
        const byte2 = parseInt(paddedHexString.substring(2, 4), 16) & 255;
        const hexString1 = (writeNum-12).toString(16)
        const paddedHexString1 = hexString1.padStart(4, '0');
        // 填充数据长度 (SSID长度 + SSID + 密码长度 + 密码)
        const byte3 = parseInt(paddedHexString1.substring(0, 2), 16) & 255;
        const byte4 = parseInt(paddedHexString1.substring(2, 4), 16) & 255;
        var writeArray=new ArrayBuffer(writeNum)
        const uint8View = new Uint8Array(writeArray);
        uint8View[0]=126 // 包头
        uint8View[1]=byte1
        uint8View[2]=byte2
        uint8View[3]=0 // 流水号
        uint8View[4]=0 // 总包数、暂无用
        uint8View[5]=1 // 对应标识端(手机)
        uint8View[6]=89  // 指令标志
        uint8View[7]=222 // 指令标志低位
        uint8View[8]=byte3 
        uint8View[9]=byte4
        uint8View[10]=ssid.length // SSID 长度
        // 填充 SSID
        for(let i=0;i<ssid_array.length;i++){
            uint8View[i+11]=ssid_array[i]
        }
        uint8View[11+ssid_array.length]=pwd.length // 密码长度

        // 填充密码
        for(let i=0;i<pwd_array.length;i++){
            uint8View[i+12+ssid_array.length]=pwd_array[i]
        }
        // 校验和计算
        var checksum=0;
        for(let i=0;i<uint8View.length-3;i++){
            checksum=checksum+uint8View[i+1]
        }
        console.log("校验和",checksum,checksum & 255)
        uint8View[writeNum - 2]=checksum & 255
        uint8View[writeNum - 1]=239
        var allStr=''
        for(let i=0;i<uint8View.length;i++){
            let hexString = uint8View[i].toString(16);
            if(hexString.length==1){
                allStr=allStr+'0'+hexString
            }else{
                allStr=allStr+hexString
            }
        }
        console.log("16进制总数据",allStr)
        console.log("总数据array",uint8View)
        wx.getBLEMTU({
            deviceId: app.BLEInformation.deviceId,
            success(res) {
                console.log(res.errMsg, res.mtu)
                wx.setBLEMTU({
                    deviceId: app.BLEInformation.deviceId,
                    mtu: 200,
                    complete(res) {
                        console.log(res.errMsg)
                        console.log("写入特征值",app.BLEInformation.writeCharaterId)
                        wx.writeBLECharacteristicValue({
                            characteristicId: app.BLEInformation.writeCharaterId,
                            deviceId: app.BLEInformation.deviceId,
                            serviceId: app.BLEInformation.writeServiceId,
                            value: uint8View.buffer,
                            success(res) {
                                console.log(res.errMsg)
                                that.setData({
                                    first_url:"/img/right.png"
                                })
                            },
                            complete(res) {
                                console.log(res.errMsg)
                            }
                        })
                    },
                })

            },
        })
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        var that=this
        console.log("接收数据特征值",app.BLEInformation.notifyServiceId,app.BLEInformation.notifyCharaterId)
        wx.notifyBLECharacteristicValueChange({
            state: true,
            deviceId: app.BLEInformation.deviceId,
            serviceId: app.BLEInformation.notifyServiceId,
            characteristicId: app.BLEInformation.notifyCharaterId,
            success(res) {
                console.log(res.errMsg)
                wx.onBLECharacteristicValueChange(function (ecRes) {
                    console.log(`characteristic ${res.characteristicId} has changed, now is ${ecRes.value}`)
                    var data = that.ab2hex(ecRes.value)
                    console.log('获取设备返回数据',data)
                    if(data[10]=='00'){
                        wx.closeBLEConnection({
                            deviceId: app.BLEInformation.deviceId,
                            complete(ress) {
                                console.log(ress)
                            }
                        })
                        clearTimeout(closeBletimerID);
                        clearInterval(intervalID)
                        wx.showModal({
                            title: '提示',
                            content: '连接成功',
                        })
                        that.setData({
                            second_url:"/img/right.png"
                        })
        
                        that.setData({
                            condition:1
                        })
                    }else{
                        wx.showModal({
                            title: '提示',
                            content: '连接失败',
                        })
                    }
                    
                })
            }
        })

        intervalID = setInterval(() => {
            if(that.data.time > 0){
                that.setData({
                    time:that.data.time - 1
                })
            }else{
                clearInterval(intervalID);
            }
        }, 1000);


        

        closeBletimerID = setTimeout(() => {
            wx.closeBLEConnection({
                deviceId: app.BLEInformation.deviceId,
                complete(res) {
                    console.log(res)
                    wx.showModal({
                        title: '错误',
                        content: '连接超时',
                    })
                    that.setData({
                        condition:1
                    })

                    wx.hideLoading({})
                }
            })
        }, 120000);
        
        this.openControl();
        console.log("onLoad")
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {
        console.log("onReady")
    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {
        console.log("onShow")
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {
        console.log("onHide")

        this.setData({
            first_url:"/img/connect.gif",
            second_url:"/img/connect.gif"
        })
        wx.closeBLEConnection({complete(res){console.log(res)}})
        wx.closeBluetoothAdapter({complete(res){console.log(res)}})
        clearInterval(intervalID)
        clearTimeout(closeBletimerID)
        intervalID = -1
        closeBletimerID = -1
    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {
        this.setData({
            first_url:"/img/connect.gif",
            second_url:"/img/connect.gif"
        })
        wx.closeBLEConnection({complete(res){console.log(res)}})
        wx.closeBluetoothAdapter({complete(res){console.log(res)}})
        clearInterval(intervalID)
        clearTimeout(closeBletimerID)
        intervalID = -1
        closeBletimerID = -1
    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {
        console.log("onPullDownRefresh")
    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {
        console.log("onReachBottom")
    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {
        console.log("onShareAppMessage")
    },

    returnMain(){
        wx.reLaunch({
            url: '/pages/init/init',
          })
    }
})